注册 登录  
 加关注
   显示下一条  |  关闭
温馨提示!由于新浪微博认证机制调整,您的新浪微博帐号绑定已过期,请重新绑定!立即重新绑定新浪微博》  |  关闭

信息 灵感 创新

I? =Information,Inspiration,Innovation

 
 
 

日志

 
 
关于我

we are 5. Mathematics, Computation, Programming, Engineering, and Making fun of life.

网易考拉推荐

NXOpen AssociativeLine  

2014-06-09 13:15:42|  分类: UG NX |  标签: |举报 |字号 订阅

  下载LOFTER 我的照片书  |

创建了一系列的直线(等同于采用了插入->曲线->直线)菜单下的功能,只不过使用的是程序化的方式。

#include <math.h>
#define  PI 3.1415926535897932384626433832795
#include <uf_ui.h>

#include <NXOpen/NXException.hxx>
#include <NXOpen/Features_AssociativeLineBuilder.hxx>
#include <NXOpen/Features_BaseFeatureCollection.hxx>
#include <NXOpen/SelectPoint.hxx>
#include <NXOpen/Part.hxx>
#include <NXOpen/PartCollection.hxx>
#include <NXOpen/PointCollection.hxx>

using namespace NXOpen;

Session* theSession;
Part* workPart;

void CreateSomeLines()
{
    theSession = Session::GetSession();
    workPart=theSession->Parts()->Work();
    double R,theta,phi;
    int longitude,altitude;
    longitude=24;
    altitude=11;
    R=1000;
    try
    {
        for(int i=0;i<altitude;i++)
        {
            Point3d p3ds,p3de;
            phi=PI/altitude;
            p3ds.Z=R*cos(i*phi);
            p3de.Z=R*cos((i+1)*phi);
            for(int j=0;j<longitude;j++)
            {
                Features::AssociativeLine* nf(NULL);
                Features::AssociativeLineBuilder* assolb=workPart->BaseFeatures()->CreateAssociativeLineBuilder(nf);
                theta=2*PI/longitude;
                p3ds.X=R*sin(i*phi)*cos(j*theta);
                p3ds.Y=R*sin(i*phi)*sin(j*theta);
                p3de.X=R*sin((i+1)*phi)*cos(j*theta);
                p3de.Y=R*sin((i+1)*phi)*sin(j*theta);
                Point* ps=workPart->Points()->CreatePoint(p3ds);
                Point* pe=workPart->Points()->CreatePoint(p3de);
                assolb->SetStartPointOptions(Features::AssociativeLineBuilder::StartOptionPoint);
                assolb->SetEndPointOptions(Features::AssociativeLineBuilder::EndOptionPoint);
                assolb->StartPoint()->SetValue(ps);
                assolb->EndPoint()->SetValue(pe);
                assolb->Commit();
                assolb->Destroy();
            }
        }
    }
    catch(const NXException &ex)
    {
        char msg[100];
        sprintf_s(msg,"%s",ex.GetMessage());
        uc1601(msg,1);
    }
}

//入口函数
extern "C" DllExport void ufsta( char *param, int *returnCode, int rlen)
{
    CreateSomeLines();
}
//退出函数
extern "C" DllExport int ufusr_ask_unload()
{
    return (int)Session::LibraryUnloadOptionImmediately;
}

截图:

CX_0609_131417

  评论这张
 
阅读(587)| 评论(0)
推荐 转载

历史上的今天

评论

<#--最新日志,群博日志--> <#--推荐日志--> <#--引用记录--> <#--博主推荐--> <#--随机阅读--> <#--首页推荐--> <#--历史上的今天--> <#--被推荐日志--> <#--上一篇,下一篇--> <#-- 热度 --> <#-- 网易新闻广告 --> <#--右边模块结构--> <#--评论模块结构--> <#--引用模块结构--> <#--博主发起的投票-->
 
 
 
 
 
 
 
 
 
 
 
 
 
 

页脚

网易公司版权所有 ©1997-2016